﻿/*
 * TismTool © Tis Veugen, 2010-2012
 *
 * File: driver.cs
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TsmRTE;

namespace Foreign
{
  public class DriverClass : TsmClass, IDriverServer
  {
    private MyTsmIPort_IDriverServer TsmPI__Port;
    private TsmIPort_ICbDriverServer Port;

    private double dPar = 1.0;
    private long L10 = 55;

    public DriverClass( TsmBase oParent, string sInstanceName )
    {
      TsmPI__Port = new MyTsmIPort_IDriverServer( this );
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch ( sPortName )
      {
      case "DriverPort":
        return TsmPI__Port;
      default:
        break;
      }
      string s = "No port '" + sPortName + "' @ DriverClass";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch ( sPortName )
      {
      case "DriverPort":
        Port = (TsmIPort_ICbDriverServer) oProvidedInterface;
        // Do NOT fill in Port.Source !!
        return;
      default:
        break;
      }
      string s = "No port '" + sPortName + "' @ DriverClass";
      throw new TsmException( s );
    }

    // ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
    public long Begin( int iPar )
    {
      Port.CbBegin( dPar );
      return L10;
    }
  }


  public class DriverForeign : TsmPComponent
  {
    private DriverClass m_DriverClass;

    public DriverForeign( TsmBase oParent, string sInstanceName )
    {
      m_DriverClass = new DriverClass( this, "DriverClass" );
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch ( sPortName )
      {
      case "d_pp_Driver":
        return m_DriverClass.GetProvidedInterface( "DriverPort" );
      default:
        break;
      }
      string s = "No port '" + sPortName + "' @ DriverForeign";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch ( sPortName )
      {
      case "d_pp_Driver":
        m_DriverClass.SetRequiredInterface( "DriverPort", oProvidedInterface );
        return;
      default:
        break;
      }
      string s = "No port '" + sPortName + "' @ DriverForeign";
      throw new TsmException( s );
    }
  }


  public class MyTsmIPort_IDriverServer : TsmIPort_IDriverServer
  {
    private DriverClass m_DriverClass;

    public MyTsmIPort_IDriverServer( DriverClass oParent )
      : base( oParent )
    {
      m_DriverClass = oParent;
    }

    public override long Begin( int iPar )
    {
      return m_DriverClass.Begin( iPar );
    }
  }
}

