/*
 * File: Foreign.cs
 * Date: 06 aug 2012
 * Time: 11:01:19
 * Generated by TismTool version 0.9
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *      7 ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > pp_User )
 *      8 ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > rp_Driver )
 *     20 ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > pp_User )
 *     21 ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > rp_Driver )
 *     39 ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > pp_Driver )
 *     51 ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > pp_Driver )
 *     63 ( Xmi > Data > Protocols > Ctlr > CtlrClient > Port )
 *     73 ( Xmi > Data > Protocols > Ctlr > CtlrServer > Port )
 *     84 ( Xmi > Data > Protocols > Driver > DriverClient > Port )
 *     94 ( Xmi > Data > Protocols > Driver > DriverServer > Port )
 * Triggers:
 *      1 int ICtlrServer___Start( Boolean bStart )
 *      2 void ICbDriverServer___CbBegin( double dPar )
 *      3 long IDriverServer___Begin( int iPar )
 *      4 void ICbCtlrServer___CbStarted( float fCbStart )
 * Natives:
 *    -70 ( CtlrClientPsm >> Idle ) ->
 *        ( CtlrClientPsm >> Starting )
 *        iRv=Start(true);
 *     81 ( CtlrServerPsm >> Starting ) ->
 *        ( CtlrServerPsm >> Idle )
 *        CbStarted((float)3.14);
 *    -91 ( DriverClientPsm >> Idle ) ->
 *        ( DriverClientPsm >> Beginning )
 *        lRv = Begin(iBeginPar);
 *    102 ( DriverServerPsm >> Beginning ) ->
 *        ( DriverServerPsm >> Idle )
 *        CbBegin( dPar );
 *    103 ( DriverServerPsm >> Beginning ) ->
 *        ( DriverServerPsm >> Idle )
 *        CbBegin( 3.14 );
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TsmRTE;

namespace Foreign
{
  public partial class Foreign
  {
    static void ArgsHandle( string[] args )
    {
      for ( int i=0; i<args.Length; i++ )
      {
        char [] ca = args[ i ].ToCharArray();
        if ( ( ca.Length >= 2 ) && ( ca[ 0 ] == '-' ) )
        {
          switch ( ca[1] )
          {
          case 'l' :
            if ( ( ca.Length >= 4 ) && ( ca[ 2 ] == '=' ) )
            {
              int ll = Convert.ToInt32( args[ i ].Substring( 3 ) );
              Tsm.SetLogLevel( ll );
            }
            break;
          case 'C' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetLogConsole( ca[ 2 ] == '+' );
            }
            break;
          case 'L' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetLogFile( ca[ 2 ] == '+' );
            }
            break;
          case 'S' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetSeqFile( ca[ 2 ] == '+' );
            }
            break;
          }
        }
      }
    }

    static void Main( string[] args )
    {
      ArgsHandle( args );
      try
      {
        TsmSystem ts = new TsmSystem( null );
        ts.Activate();
        ts.Execute();
        ts.Deactivate();
      }
      catch ( Exception exc )
      {
        Tsm.Log( "*** TsmSystem Exception ***" );
        Tsm.Log( exc.Message );
        Tsm.Log( exc.StackTrace );
      }
    }
  }

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> InitialState )
  public class Ini_0010_0011 : TsmPseudo
  {
    public Ini_0010_0011( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 14, "( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 14; // TRLS ( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 14: // UP: ( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> Idle )
  public class Lea_0010_0012 : TsmLeaf
  {
    public Lea_0010_0012( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 15, "( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting ) : pp_User->Start" );
    }

    public void Tra_0010_0014( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_User___Start( Boolean bStart, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 15; // pp_User.Start
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0010_0016( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 7:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 7: // Port pp_User
        switch ( oHandler.Trigger.Command )
        {
        case 1: // pp_User___Start
          {
            TsmTrigger_ICtlrServer___Start lTrigger = (TsmTrigger_ICtlrServer___Start) oHandler.Trigger;

            pp_User___Start( lTrigger.bStart, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 14:
        Tra_0010_0014( oHandler );
        break;
      case 15: // UP: ( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting )
        bHigher = true;
        break;
      case 16:
        Tra_0010_0016( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> Starting )
  public class Lea_0010_0013 : TsmLeaf
  {
    public Lea_0010_0013( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 16, "( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle ) : rp_Driver->CbBegin" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0010_0015( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void rp_Driver___CbBegin( double dPar, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 16; // rp_Driver.CbBegin
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 8:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 8: // Port rp_Driver
        switch ( oHandler.Trigger.Command )
        {
        case 2: // rp_Driver___CbBegin
          {
            TsmTrigger_ICbDriverServer___CbBegin lTrigger = (TsmTrigger_ICbDriverServer___CbBegin) oHandler.Trigger;

            rp_Driver___CbBegin( lTrigger.dPar, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 15:
        Tra_0010_0015( oHandler );
        break;
      case 16: // UP: ( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >)
  public class Reg_0009_0010 : TsmRegion
  {
    private Ini_0010_0011 oIni_0010_0011; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> InitialState )
    private Lea_0010_0012 oLea_0010_0012; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> Idle )
    private Lea_0010_0013 oLea_0010_0013; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >> Starting )

    public Reg_0009_0010( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0010_0011 = new Ini_0010_0011( this );
      oLea_0010_0012 = new Lea_0010_0012( this );
      oLea_0010_0013 = new Lea_0010_0013( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0010_0011;
      mStates[ 1 ] = oLea_0010_0012;
      mStates[ 2 ] = oLea_0010_0013;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0010_0011.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )
    public void Tra_0010_0014( TsmHandler oHandler )
    {
      mCurrentState = oLea_0010_0012; // At: ( CtlrClassFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting )
    public void Tra_0010_0015( TsmHandler oHandler )
    {
      ((Cla_0004_0006)oHandler.Owner).Function_1008( oHandler );
      mCurrentState = oLea_0010_0013; // At: ( CtlrClassFsm >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle )
    public void Tra_0010_0016( TsmHandler oHandler )
    {
      ((Cla_0004_0006)oHandler.Owner).Function_1009( oHandler );
      mCurrentState = oLea_0010_0012; // At: ( CtlrClassFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 7:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 7
      case 8:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 14:
        Tra_0010_0014( oHandler );
        break;
      case 15:
        Tra_0010_0015( oHandler );
        break;
      case 16:
        Tra_0010_0016( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm )
  public class Fsm_0006_0009 : TsmFsm
  {
    private Reg_0009_0010 oReg_0009_0010; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm >)

    public Fsm_0006_0009( TsmBase oParent )
    {
      TsmName = "CtlrClassFsm";
      TsmParent = oParent;
      oReg_0009_0010 = new Reg_0009_0010( this );
      mRegions.Add( oReg_0009_0010 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass )
  public class Cla_0004_0006 : TsmClass
  {
    private Fsm_0006_0009 oFsm_0006_0009; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > CtlrClassFsm )
    private TsmIPort_ICtlrServer TsmPI__pp_User; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > pp_User )
    private TsmIPort_ICbCtlrServer pp_User; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > pp_User )
    private TsmIPort_IDriverServer rp_Driver; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > rp_Driver )
    private TsmIPort_ICbDriverServer TsmPI__rp_Driver; // ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass > rp_Driver )
    private TsmPSPort mPSMessager;
    private TsmPCPort mPCMessager;
    private Boolean bCtrlStart = false;
    private double MyCtlrlCbPar;

    public Cla_0004_0006( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0006_0009 = new Fsm_0006_0009( this );
      TsmPI__pp_User = new TsmIPort_ICtlrServer( this );
      TsmPI__rp_Driver = new TsmIPort_ICbDriverServer( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0006_0009;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_User" :
        return TsmPI__pp_User;
      case "rp_Driver" :
        return TsmPI__rp_Driver;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_User" :
        pp_User = (TsmIPort_ICbCtlrServer) oProvidedInterface;
        pp_User.Source = this;
        return;
      case "rp_Driver" :
        rp_Driver = (TsmIPort_IDriverServer) oProvidedInterface;
        rp_Driver.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > CtlrComp > CtlrClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0006_0009.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting )
    public void Function_1008( TsmHandler oHandler )
    {
      rp_Driver.Begin( bCtrlStart ? 1 : 2);
    }

     // ( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle )
    public void Function_1009( TsmHandler oHandler )
    {
      pp_User.CbStarted( (float) MyCtlrlCbPar );
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__pp_User.PortId = 7;
      TsmPI__pp_User.Messager = mPSMessager;
      TsmPI__rp_Driver.PortId = 8;
      TsmPI__rp_Driver.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0006_0009.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > Controller > CtlrComp )
  public class Com_0003_0004 : TsmLComponent
  {
    private Cla_0004_0006 MyCtlrClass; // ( Xmi > Data > Repository > Controller > CtlrComp > MyCtlrClass )

    public Com_0003_0004( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MyCtlrClass = new Cla_0004_0006( this, "MyCtlrClass" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = MyCtlrClass;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_User" :
        return MyCtlrClass.GetProvidedInterface( "pp_User" );
      case "d_rp_Driver" :
        return MyCtlrClass.GetProvidedInterface( "rp_Driver" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > CtlrComp )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_User" :
        MyCtlrClass.SetRequiredInterface( "pp_User", oProvidedInterface );
        return;
      case "d_rp_Driver" :
        MyCtlrClass.SetRequiredInterface( "rp_Driver", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > CtlrComp )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> InitialState )
  public class Ini_0023_0024 : TsmPseudo
  {
    public Ini_0023_0024( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 27, "( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 27; // TRLS ( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27: // UP: ( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> Idle )
  public class Lea_0023_0025 : TsmLeaf
  {
    public Lea_0023_0025( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 28, "( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting ) : pp_User->Start" );
    }

    public void Tra_0023_0027( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_User___Start( Boolean bStart, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 28; // pp_User.Start
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0023_0029( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 20:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 20: // Port pp_User
        switch ( oHandler.Trigger.Command )
        {
        case 1: // pp_User___Start
          {
            TsmTrigger_ICtlrServer___Start lTrigger = (TsmTrigger_ICtlrServer___Start) oHandler.Trigger;

            pp_User___Start( lTrigger.bStart, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27:
        Tra_0023_0027( oHandler );
        break;
      case 28: // UP: ( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting )
        bHigher = true;
        break;
      case 29:
        Tra_0023_0029( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> Starting )
  public class Lea_0023_0026 : TsmLeaf
  {
    public Lea_0023_0026( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 29, "( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle ) : rp_Driver->CbBegin" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0023_0028( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void rp_Driver___CbBegin( double dPar, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 29; // rp_Driver.CbBegin
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 21:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 21: // Port rp_Driver
        switch ( oHandler.Trigger.Command )
        {
        case 2: // rp_Driver___CbBegin
          {
            TsmTrigger_ICbDriverServer___CbBegin lTrigger = (TsmTrigger_ICbDriverServer___CbBegin) oHandler.Trigger;

            rp_Driver___CbBegin( lTrigger.dPar, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 28:
        Tra_0023_0028( oHandler );
        break;
      case 29: // UP: ( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >)
  public class Reg_0022_0023 : TsmRegion
  {
    private Ini_0023_0024 oIni_0023_0024; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> InitialState )
    private Lea_0023_0025 oLea_0023_0025; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> Idle )
    private Lea_0023_0026 oLea_0023_0026; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >> Starting )

    public Reg_0022_0023( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0023_0024 = new Ini_0023_0024( this );
      oLea_0023_0025 = new Lea_0023_0025( this );
      oLea_0023_0026 = new Lea_0023_0026( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0023_0024;
      mStates[ 1 ] = oLea_0023_0025;
      mStates[ 2 ] = oLea_0023_0026;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0023_0024.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClassFsm >> InitialState ) => ( CtlrClassFsm >> Idle )
    public void Tra_0023_0027( TsmHandler oHandler )
    {
      mCurrentState = oLea_0023_0025; // At: ( CtlrClassFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting )
    public void Tra_0023_0028( TsmHandler oHandler )
    {
      ((Cla_0017_0019)oHandler.Owner).Function_1010( oHandler );
      mCurrentState = oLea_0023_0026; // At: ( CtlrClassFsm >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle )
    public void Tra_0023_0029( TsmHandler oHandler )
    {
      ((Cla_0017_0019)oHandler.Owner).Function_1011( oHandler );
      mCurrentState = oLea_0023_0025; // At: ( CtlrClassFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 20:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 20
      case 21:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 27:
        Tra_0023_0027( oHandler );
        break;
      case 28:
        Tra_0023_0028( oHandler );
        break;
      case 29:
        Tra_0023_0029( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm )
  public class Fsm_0019_0022 : TsmFsm
  {
    private Reg_0022_0023 oReg_0022_0023; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm >)

    public Fsm_0019_0022( TsmBase oParent )
    {
      TsmName = "CtlrClassFsm";
      TsmParent = oParent;
      oReg_0022_0023 = new Reg_0022_0023( this );
      mRegions.Add( oReg_0022_0023 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass )
  public class Cla_0017_0019 : TsmClass
  {
    private Fsm_0019_0022 oFsm_0019_0022; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > CtlrClassFsm )
    private TsmIPort_ICtlrServer TsmPI__pp_User; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > pp_User )
    private TsmIPort_ICbCtlrServer pp_User; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > pp_User )
    private TsmIPort_IDriverServer rp_Driver; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > rp_Driver )
    private TsmIPort_ICbDriverServer TsmPI__rp_Driver; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass > rp_Driver )
    private TsmPSPort mPSMessager;
    private TsmPCPort mPCMessager;
    private Boolean bCtrlStart = true;
    private double MyCtlrlCbPar;

    public Cla_0017_0019( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0019_0022 = new Fsm_0019_0022( this );
      TsmPI__pp_User = new TsmIPort_ICtlrServer( this );
      TsmPI__rp_Driver = new TsmIPort_ICbDriverServer( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0019_0022;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_User" :
        return TsmPI__pp_User;
      case "rp_Driver" :
        return TsmPI__rp_Driver;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_User" :
        pp_User = (TsmIPort_ICbCtlrServer) oProvidedInterface;
        pp_User.Source = this;
        return;
      case "rp_Driver" :
        rp_Driver = (TsmIPort_IDriverServer) oProvidedInterface;
        rp_Driver.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > ThrCtlrComp > CtlrClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0019_0022.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( CtlrClassFsm >> Idle ) => ( CtlrClassFsm >> Starting )
    public void Function_1010( TsmHandler oHandler )
    {
      rp_Driver.Begin( bCtrlStart ? 3 : 4);
      oHandler.Trigger.Ready();
    }

     // ( CtlrClassFsm >> Starting ) => ( CtlrClassFsm >> Idle )
    public void Function_1011( TsmHandler oHandler )
    {
      pp_User.CbStarted( (float) MyCtlrlCbPar );
      TsmSupervisor.Abandon();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__pp_User.PortId = 20;
      TsmPI__pp_User.Messager = mPSMessager;
      TsmPI__rp_Driver.PortId = 21;
      TsmPI__rp_Driver.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0019_0022.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > Controller > ThrCtlrComp )
  public class Com_0003_0017 : TsmAComponent
  {
    private Cla_0017_0019 MyCtlrClass; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > MyCtlrClass )
    private TsmIPort_ICtlrServer TsmPI__d_pp_User; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > d_pp_User )
    private TsmASPort TsmMr__d_pp_User;
    private TsmIPort_ICbDriverServer TsmPI__d_rp_Driver; // ( Xmi > Data > Repository > Controller > ThrCtlrComp > d_rp_Driver )
    private TsmACPort TsmMr__d_rp_Driver;

    public Com_0003_0017( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MyCtlrClass = new Cla_0017_0019( this, "MyCtlrClass" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = MyCtlrClass;
      TsmPI__d_pp_User = new TsmIPort_ICtlrServer( this );
      TsmMr__d_pp_User = new TsmASPort();
      TsmPI__d_rp_Driver = new TsmIPort_ICbDriverServer( this );
      TsmMr__d_rp_Driver = new TsmACPort();
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_User" :
        return TsmPI__d_pp_User;
      case "d_rp_Driver" :
        return TsmPI__d_rp_Driver;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > ThrCtlrComp )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_User" :
        MyCtlrClass.SetRequiredInterface( "pp_User", oProvidedInterface );
        return;
      case "d_rp_Driver" :
        MyCtlrClass.SetRequiredInterface( "rp_Driver", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Controller > ThrCtlrComp )";
      throw new TsmException( s );
    }

    public override void TsmInitialise( object oObject )
    {
      base.TsmInitialise( oObject );
      TsmMr__d_pp_User.Thread = Thread;
      TsmPI__d_pp_User.Messager = TsmMr__d_pp_User;
      TsmMr__d_rp_Driver.Thread = Thread;
      TsmPI__d_rp_Driver.Messager = TsmMr__d_rp_Driver;
    }

    public override void TsmConnect( object oObject )
    {
      TsmInterfacePort ClassPort;
      ClassPort = MyCtlrClass.GetProvidedInterface( "pp_User" );
      TsmPI__d_pp_User.PortId = ClassPort.PortId;
      TsmMr__d_pp_User.Target = ClassPort.Messager.Target;
      ClassPort = MyCtlrClass.GetProvidedInterface( "rp_Driver" );
      TsmPI__d_rp_Driver.PortId = ClassPort.PortId;
      TsmMr__d_rp_Driver.Target = ClassPort.Messager.Target;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Controller )
   ********************************************************************/

   // ( Xmi > Data > Repository > Controller )
  public class Pac_0002_0003 : TsmPackage
  {
    public Pac_0002_0003( TsmBase oParent )
    {
      TsmName = "Controller";
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > UserForeign )
  public class Com_0030_0031 : TsmPComponent
  {
    public Com_0030_0031( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > DriverForeign )
  public class Com_0030_0032 : TsmPComponent
  {
    public Com_0030_0032( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > DriverMock )
  public class Com_0030_0033 : TsmPComponent
  {
    public Com_0030_0033( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > UserMock )
  public class Com_0030_0034 : TsmPComponent
  {
    public Com_0030_0034( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Terminators )
   ********************************************************************/

   // ( Xmi > Data > Repository > Terminators )
  public class Pac_0002_0030 : TsmPackage
  {
    public Pac_0002_0030( TsmBase oParent )
    {
      TsmName = "Terminators";
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> InitialState )
  public class Ini_0041_0042 : TsmPseudo
  {
    public Ini_0041_0042( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 45, "( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 45; // TRLS ( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 45: // UP: ( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> Idle )
  public class Lea_0041_0043 : TsmLeaf
  {
    public Lea_0041_0043( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 46, "( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning ) : pp_Driver->Begin" );
    }

    public void Tra_0041_0045( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0041_0047( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void pp_Driver___Begin( int iPar, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 46; // pp_Driver.Begin
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 39:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 39: // Port pp_Driver
        switch ( oHandler.Trigger.Command )
        {
        case 3: // pp_Driver___Begin
          {
            TsmTrigger_IDriverServer___Begin lTrigger = (TsmTrigger_IDriverServer___Begin) oHandler.Trigger;

            pp_Driver___Begin( lTrigger.iPar, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 45:
        Tra_0041_0045( oHandler );
        break;
      case 47:
        Tra_0041_0047( oHandler );
        break;
      case 46: // UP: ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> Beginning )
  public class Lea_0041_0044 : TsmLeaf
  {
    public Lea_0041_0044( TsmBase oParent )
    {
      TsmName = "Beginning";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 47, "( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 47; // TRLS ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0041_0046( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 47: // UP: ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
        bHigher = true;
        break;
      case 46:
        Tra_0041_0046( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >)
  public class Reg_0040_0041 : TsmRegion
  {
    private Ini_0041_0042 oIni_0041_0042; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> InitialState )
    private Lea_0041_0043 oLea_0041_0043; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> Idle )
    private Lea_0041_0044 oLea_0041_0044; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >> Beginning )

    public Reg_0040_0041( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0041_0042 = new Ini_0041_0042( this );
      oLea_0041_0043 = new Lea_0041_0043( this );
      oLea_0041_0044 = new Lea_0041_0044( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0041_0042;
      mStates[ 1 ] = oLea_0041_0043;
      mStates[ 2 ] = oLea_0041_0044;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0041_0042.ExecuteHandler( oHandler );
    }

     // At: ( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )
    public void Tra_0041_0045( TsmHandler oHandler )
    {
      mCurrentState = oLea_0041_0043; // At: ( DriverClassFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
    public void Tra_0041_0047( TsmHandler oHandler )
    {
      ((Cla_0036_0038)oHandler.Owner).Function_1001( oHandler );
      mCurrentState = oLea_0041_0043; // At: ( DriverClassFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
    public void Tra_0041_0046( TsmHandler oHandler )
    {
      ((Cla_0036_0038)oHandler.Owner).Function_1013( oHandler );
      mCurrentState = oLea_0041_0044; // At: ( DriverClassFsm >> Beginning )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 39:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 45:
        Tra_0041_0045( oHandler );
        break;
      case 47:
        Tra_0041_0047( oHandler );
        break;
      case 46:
        Tra_0041_0046( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm )
  public class Fsm_0038_0040 : TsmFsm
  {
    private Reg_0040_0041 oReg_0040_0041; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm >)

    public Fsm_0038_0040( TsmBase oParent )
    {
      TsmName = "DriverClassFsm";
      TsmParent = oParent;
      oReg_0040_0041 = new Reg_0040_0041( this );
      mRegions.Add( oReg_0040_0041 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass )
  public class Cla_0036_0038 : TsmClass
  {
    private Fsm_0038_0040 oFsm_0038_0040; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > DriverClassFsm )
    private TsmIPort_IDriverServer TsmPI__pp_Driver; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > pp_Driver )
    private TsmIPort_ICbDriverServer pp_Driver; // ( Xmi > Data > Repository > Driver > DriverComp > DriverClass > pp_Driver )
    private TsmPSPort mPSMessager;

    public Cla_0036_0038( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0038_0040 = new Fsm_0038_0040( this );
      TsmPI__pp_Driver = new TsmIPort_IDriverServer( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0038_0040;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_Driver" :
        return TsmPI__pp_Driver;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > DriverComp > DriverClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_Driver" :
        pp_Driver = (TsmIPort_ICbDriverServer) oProvidedInterface;
        pp_Driver.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > DriverComp > DriverClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0038_0040.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
    public void Function_1001( TsmHandler oHandler )
    {
      pp_Driver.CbBegin(4.5);
    }

     // ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
    public long Function_1012( int iPar )
    {
      return 55;
    }

     // ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
    public void Function_1013( TsmHandler oHandler )
    {
      TsmTrigger_IDriverServer___Begin lTrigger = (TsmTrigger_IDriverServer___Begin) oHandler.Trigger;
      int iPar = lTrigger.iPar;

      lTrigger._RetVal = ((Cla_0036_0038)oHandler.Owner).Function_1012( iPar );
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__pp_Driver.PortId = 39;
      TsmPI__pp_Driver.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0038_0040.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > Driver > DriverComp )
  public class Com_0035_0036 : TsmPComponent
  {
    private Cla_0036_0038 MyDriverClass; // ( Xmi > Data > Repository > Driver > DriverComp > MyDriverClass )

    public Com_0035_0036( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MyDriverClass = new Cla_0036_0038( this, "MyDriverClass" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = MyDriverClass;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        return MyDriverClass.GetProvidedInterface( "pp_Driver" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > DriverComp )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        MyDriverClass.SetRequiredInterface( "pp_Driver", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > DriverComp )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> InitialState )
  public class Ini_0053_0054 : TsmPseudo
  {
    public Ini_0053_0054( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 57, "( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 57; // TRLS ( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57: // UP: ( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> Idle )
  public class Lea_0053_0055 : TsmLeaf
  {
    public Lea_0053_0055( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 58, "( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning ) : pp_Driver->Begin" );
    }

    public void Tra_0053_0057( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0053_0059( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void pp_Driver___Begin( int iPar, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 58; // pp_Driver.Begin
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 51:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 51: // Port pp_Driver
        switch ( oHandler.Trigger.Command )
        {
        case 3: // pp_Driver___Begin
          {
            TsmTrigger_IDriverServer___Begin lTrigger = (TsmTrigger_IDriverServer___Begin) oHandler.Trigger;

            pp_Driver___Begin( lTrigger.iPar, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57:
        Tra_0053_0057( oHandler );
        break;
      case 59:
        Tra_0053_0059( oHandler );
        break;
      case 58: // UP: ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> Beginning )
  public class Lea_0053_0056 : TsmLeaf
  {
    public Lea_0053_0056( TsmBase oParent )
    {
      TsmName = "Beginning";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 59, "( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 59; // TRLS ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0053_0058( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 59: // UP: ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
        bHigher = true;
        break;
      case 58:
        Tra_0053_0058( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >)
  public class Reg_0052_0053 : TsmRegion
  {
    private Ini_0053_0054 oIni_0053_0054; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> InitialState )
    private Lea_0053_0055 oLea_0053_0055; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> Idle )
    private Lea_0053_0056 oLea_0053_0056; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >> Beginning )

    public Reg_0052_0053( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0053_0054 = new Ini_0053_0054( this );
      oLea_0053_0055 = new Lea_0053_0055( this );
      oLea_0053_0056 = new Lea_0053_0056( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0053_0054;
      mStates[ 1 ] = oLea_0053_0055;
      mStates[ 2 ] = oLea_0053_0056;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0053_0054.ExecuteHandler( oHandler );
    }

     // At: ( DriverClassFsm >> InitialState ) => ( DriverClassFsm >> Idle )
    public void Tra_0053_0057( TsmHandler oHandler )
    {
      mCurrentState = oLea_0053_0055; // At: ( DriverClassFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
    public void Tra_0053_0059( TsmHandler oHandler )
    {
      ((Cla_0048_0050)oHandler.Owner).Function_1002( oHandler );
      mCurrentState = oLea_0053_0055; // At: ( DriverClassFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
    public void Tra_0053_0058( TsmHandler oHandler )
    {
      ((Cla_0048_0050)oHandler.Owner).Function_1015( oHandler );
      mCurrentState = oLea_0053_0056; // At: ( DriverClassFsm >> Beginning )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 51:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57:
        Tra_0053_0057( oHandler );
        break;
      case 59:
        Tra_0053_0059( oHandler );
        break;
      case 58:
        Tra_0053_0058( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm )
  public class Fsm_0050_0052 : TsmFsm
  {
    private Reg_0052_0053 oReg_0052_0053; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm >)

    public Fsm_0050_0052( TsmBase oParent )
    {
      TsmName = "DriverClassFsm";
      TsmParent = oParent;
      oReg_0052_0053 = new Reg_0052_0053( this );
      mRegions.Add( oReg_0052_0053 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass )
  public class Cla_0048_0050 : TsmClass
  {
    private Fsm_0050_0052 oFsm_0050_0052; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > DriverClassFsm )
    private TsmIPort_IDriverServer TsmPI__pp_Driver; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > pp_Driver )
    private TsmIPort_ICbDriverServer pp_Driver; // ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass > pp_Driver )
    private TsmPSPort mPSMessager;

    public Cla_0048_0050( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0050_0052 = new Fsm_0050_0052( this );
      TsmPI__pp_Driver = new TsmIPort_IDriverServer( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0050_0052;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_Driver" :
        return TsmPI__pp_Driver;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_Driver" :
        pp_Driver = (TsmIPort_ICbDriverServer) oProvidedInterface;
        pp_Driver.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > ThrDriverComp > DriverClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0050_0052.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( DriverClassFsm >> Beginning ) => ( DriverClassFsm >> Idle )
    public void Function_1002( TsmHandler oHandler )
    {
      pp_Driver.CbBegin(4.5);
    }

     // ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
    public long Function_1014( int iPar )
    {
      return 55;
    }

     // ( DriverClassFsm >> Idle ) => ( DriverClassFsm >> Beginning )
    public void Function_1015( TsmHandler oHandler )
    {
      TsmTrigger_IDriverServer___Begin lTrigger = (TsmTrigger_IDriverServer___Begin) oHandler.Trigger;
      int iPar = lTrigger.iPar;

      lTrigger._RetVal = ((Cla_0048_0050)oHandler.Owner).Function_1014( iPar );

      oHandler.Trigger.Ready();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__pp_Driver.PortId = 51;
      TsmPI__pp_Driver.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0050_0052.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > Driver > ThrDriverComp )
  public class Com_0035_0048 : TsmAComponent
  {
    private Cla_0048_0050 MyDriverClass; // ( Xmi > Data > Repository > Driver > ThrDriverComp > MyDriverClass )
    private TsmIPort_IDriverServer TsmPI__d_pp_Driver; // ( Xmi > Data > Repository > Driver > ThrDriverComp > d_pp_Driver )
    private TsmASPort TsmMr__d_pp_Driver;

    public Com_0035_0048( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MyDriverClass = new Cla_0048_0050( this, "MyDriverClass" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = MyDriverClass;
      TsmPI__d_pp_Driver = new TsmIPort_IDriverServer( this );
      TsmMr__d_pp_Driver = new TsmASPort();
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        return TsmPI__d_pp_Driver;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > ThrDriverComp )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        MyDriverClass.SetRequiredInterface( "pp_Driver", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Driver > ThrDriverComp )";
      throw new TsmException( s );
    }

    public override void TsmInitialise( object oObject )
    {
      base.TsmInitialise( oObject );
      TsmMr__d_pp_Driver.Thread = Thread;
      TsmPI__d_pp_Driver.Messager = TsmMr__d_pp_Driver;
    }

    public override void TsmConnect( object oObject )
    {
      TsmInterfacePort ClassPort;
      ClassPort = MyDriverClass.GetProvidedInterface( "pp_Driver" );
      TsmPI__d_pp_Driver.PortId = ClassPort.PortId;
      TsmMr__d_pp_Driver.Target = ClassPort.Messager.Target;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Driver )
   ********************************************************************/

   // ( Xmi > Data > Repository > Driver )
  public class Pac_0002_0035 : TsmPackage
  {
    public Pac_0002_0035( TsmBase oParent )
    {
      TsmName = "Driver";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository )
   ********************************************************************/

   // ( Xmi > Data > Repository )
  public class Pac_0001_0002 : TsmPackage
  {
    public Pac_0001_0002( TsmBase oParent )
    {
      TsmName = "Repository";
      TsmParent = oParent;
    }
  }

  public interface ICtlrServer
  {
    int Start( Boolean bStart );
  }

  public class TsmTrigger_ICtlrServer___Start : TsmTrigger
  {
    public int _RetVal;
    public Boolean bStart;

    public TsmTrigger_ICtlrServer___Start( Boolean bStart )
      : base( 1 )
    {
      this.bStart = bStart;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > ICtlrServer )
  public class TsmIPort_ICtlrServer : TsmInterfacePort, ICtlrServer
  {
    public TsmIPort_ICtlrServer( TsmBase oParent )
    {
      TsmName = "ICtlrServer";
      TsmParent = oParent;
    }

    public virtual int Start( Boolean bStart )
    {
      TsmTrigger_ICtlrServer___Start tt = new TsmTrigger_ICtlrServer___Start( bStart );
      TsmRecorder.AddCall( "Start", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
      return tt._RetVal;
    }
  }

  public interface ICbCtlrServer
  {
    void CbStarted( float fCbStart );
  }

  public class TsmTrigger_ICbCtlrServer___CbStarted : TsmTrigger
  {
    public float fCbStart;

    public TsmTrigger_ICbCtlrServer___CbStarted( float fCbStart )
      : base( 4 )
    {
      this.fCbStart = fCbStart;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > ICbCtlrServer )
  public class TsmIPort_ICbCtlrServer : TsmInterfacePort, ICbCtlrServer
  {
    public TsmIPort_ICbCtlrServer( TsmBase oParent )
    {
      TsmName = "ICbCtlrServer";
      TsmParent = oParent;
    }

    public virtual void CbStarted( float fCbStart )
    {
      TsmTrigger_ICbCtlrServer___CbStarted tt = new TsmTrigger_ICbCtlrServer___CbStarted( fCbStart );
      TsmRecorder.AddCall( "CbStarted", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> InitialState )
  public class Ini_0065_0066 : TsmPseudo
  {
    public Ini_0065_0066( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 69, "( CtlrClientPsm >> InitialState ) => ( CtlrClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 69; // TRLS ( CtlrClientPsm >> InitialState ) => ( CtlrClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69: // UP: ( CtlrClientPsm >> InitialState ) => ( CtlrClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> Idle )
  public class Lea_0065_0067 : TsmLeaf
  {
    int [] aNatives = { -70 };

    public Lea_0065_0067( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 70, "( CtlrClientPsm >> Idle ) => ( CtlrClientPsm >> Starting )" );
    }

    public void Tra_0065_0069( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0065_0071( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 70:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 70: // Native: ( CtlrClientPsm >> Idle ) => ( CtlrClientPsm >> Starting )
          TsmRecorder.AddNative( "( CtlrClientPsm >> Idle ) => ( CtlrClientPsm >> Starting ) # iRv=Start(true);" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 70;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69:
        Tra_0065_0069( oHandler );
        break;
      case 70: // UP: ( CtlrClientPsm >> Idle ) => ( CtlrClientPsm >> Starting )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 71:
        Tra_0065_0071( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> Starting )
  public class Lea_0065_0068 : TsmLeaf
  {
    public Lea_0065_0068( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 71, "( CtlrClientPsm >> Starting ) => ( CtlrClientPsm >> Idle ) : CbStarted" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0065_0070( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbStarted( float fCbStart, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 71; // CbStarted
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 63:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 63: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 4: // Port___CbStarted
          {
            TsmTrigger_ICbCtlrServer___CbStarted lTrigger = (TsmTrigger_ICbCtlrServer___CbStarted) oHandler.Trigger;

            Port___CbStarted( lTrigger.fCbStart, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 70:
        Tra_0065_0070( oHandler );
        break;
      case 71: // UP: ( CtlrClientPsm >> Starting ) => ( CtlrClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >)
  public class Reg_0064_0065 : TsmRegion
  {
    private Ini_0065_0066 oIni_0065_0066; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> InitialState )
    private Lea_0065_0067 oLea_0065_0067; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> Idle )
    private Lea_0065_0068 oLea_0065_0068; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >> Starting )

    public Reg_0064_0065( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0065_0066 = new Ini_0065_0066( this );
      oLea_0065_0067 = new Lea_0065_0067( this );
      oLea_0065_0068 = new Lea_0065_0068( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0065_0066;
      mStates[ 1 ] = oLea_0065_0067;
      mStates[ 2 ] = oLea_0065_0068;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0065_0066.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClientPsm >> InitialState ) => ( CtlrClientPsm >> Idle )
    public void Tra_0065_0069( TsmHandler oHandler )
    {
      mCurrentState = oLea_0065_0067; // At: ( CtlrClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClientPsm >> Idle ) => ( CtlrClientPsm >> Starting )
    public void Tra_0065_0070( TsmHandler oHandler )
    {
      ((Cla_0061_0062)oHandler.Owner).Function_1003( oHandler );
      mCurrentState = oLea_0065_0068; // At: ( CtlrClientPsm >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CtlrClientPsm >> Starting ) => ( CtlrClientPsm >> Idle )
    public void Tra_0065_0071( TsmHandler oHandler )
    {
      mCurrentState = oLea_0065_0067; // At: ( CtlrClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 70:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 63:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 69:
        Tra_0065_0069( oHandler );
        break;
      case 70:
        Tra_0065_0070( oHandler );
        break;
      case 71:
        Tra_0065_0071( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm )
  public class Fsm_0062_0064 : TsmFsm
  {
    private Reg_0064_0065 oReg_0064_0065; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm >)

    public Fsm_0062_0064( TsmBase oParent )
    {
      TsmName = "CtlrClientPsm";
      TsmParent = oParent;
      oReg_0064_0065 = new Reg_0064_0065( this );
      mRegions.Add( oReg_0064_0065 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrClient )
  public class Cla_0061_0062 : TsmProtocolClass
  {
    private Fsm_0062_0064 oFsm_0062_0064; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > CtlrClientPsm )
    private TsmIPort_ICtlrServer Port; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > Port )
    private TsmIPort_ICbCtlrServer TsmPI__Port; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > Port )
    private TsmPCPort mPCMessager;
    private int iRv = 0;

    public Cla_0061_0062( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0062_0064 = new Fsm_0062_0064( this );
      TsmPI__Port = new TsmIPort_ICbCtlrServer( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0062_0064;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Ctlr > CtlrClient )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICtlrServer) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Ctlr > CtlrClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0062_0064.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( CtlrClientPsm >> Idle ) => ( CtlrClientPsm >> Starting )
    public void Function_1003( TsmHandler oHandler )
    {
      iRv=Port.Start(true);
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 63;
      TsmPI__Port.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0062_0064.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> InitialState )
  public class Ini_0075_0076 : TsmPseudo
  {
    public Ini_0075_0076( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 79, "( CtlrServerPsm >> InitialState ) => ( CtlrServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 79; // TRLS ( CtlrServerPsm >> InitialState ) => ( CtlrServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79: // UP: ( CtlrServerPsm >> InitialState ) => ( CtlrServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> Idle )
  public class Lea_0075_0077 : TsmLeaf
  {
    public Lea_0075_0077( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 80, "( CtlrServerPsm >> Idle ) => ( CtlrServerPsm >> Starting ) : Start" );
    }

    public void Tra_0075_0079( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0075_0081( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Start( Boolean bStart, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 80; // Start
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 73:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 73: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 1: // Port___Start
          {
            TsmTrigger_ICtlrServer___Start lTrigger = (TsmTrigger_ICtlrServer___Start) oHandler.Trigger;

            Port___Start( lTrigger.bStart, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79:
        Tra_0075_0079( oHandler );
        break;
      case 81:
        Tra_0075_0081( oHandler );
        break;
      case 80: // UP: ( CtlrServerPsm >> Idle ) => ( CtlrServerPsm >> Starting )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> Starting )
  public class Lea_0075_0078 : TsmLeaf
  {
    int [] aNatives = { 81 };

    public Lea_0075_0078( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 81, "( CtlrServerPsm >> Starting ) => ( CtlrServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0075_0080( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 81:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 81: // Native: ( CtlrServerPsm >> Starting ) => ( CtlrServerPsm >> Idle )
          TsmRecorder.AddNative( "( CtlrServerPsm >> Starting ) => ( CtlrServerPsm >> Idle ) # CbStarted((float)3.14);" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 81;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 81: // UP: ( CtlrServerPsm >> Starting ) => ( CtlrServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 80:
        Tra_0075_0080( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >)
  public class Reg_0074_0075 : TsmRegion
  {
    private Ini_0075_0076 oIni_0075_0076; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> InitialState )
    private Lea_0075_0077 oLea_0075_0077; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> Idle )
    private Lea_0075_0078 oLea_0075_0078; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >> Starting )

    public Reg_0074_0075( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0075_0076 = new Ini_0075_0076( this );
      oLea_0075_0077 = new Lea_0075_0077( this );
      oLea_0075_0078 = new Lea_0075_0078( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0075_0076;
      mStates[ 1 ] = oLea_0075_0077;
      mStates[ 2 ] = oLea_0075_0078;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0075_0076.ExecuteHandler( oHandler );
    }

     // At: ( CtlrServerPsm >> InitialState ) => ( CtlrServerPsm >> Idle )
    public void Tra_0075_0079( TsmHandler oHandler )
    {
      mCurrentState = oLea_0075_0077; // At: ( CtlrServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CtlrServerPsm >> Starting ) => ( CtlrServerPsm >> Idle )
    public void Tra_0075_0081( TsmHandler oHandler )
    {
      ((Cla_0061_0072)oHandler.Owner).Function_1004( oHandler );
      mCurrentState = oLea_0075_0077; // At: ( CtlrServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CtlrServerPsm >> Idle ) => ( CtlrServerPsm >> Starting )
    public void Tra_0075_0080( TsmHandler oHandler )
    {
      ((Cla_0061_0072)oHandler.Owner).Function_1017( oHandler );
      mCurrentState = oLea_0075_0078; // At: ( CtlrServerPsm >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 81:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 73:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 79:
        Tra_0075_0079( oHandler );
        break;
      case 81:
        Tra_0075_0081( oHandler );
        break;
      case 80:
        Tra_0075_0080( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm )
  public class Fsm_0072_0074 : TsmFsm
  {
    private Reg_0074_0075 oReg_0074_0075; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm >)

    public Fsm_0072_0074( TsmBase oParent )
    {
      TsmName = "CtlrServerPsm";
      TsmParent = oParent;
      oReg_0074_0075 = new Reg_0074_0075( this );
      mRegions.Add( oReg_0074_0075 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > Ctlr > CtlrServer )
  public class Cla_0061_0072 : TsmProtocolClass
  {
    private Fsm_0072_0074 oFsm_0072_0074; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > CtlrServerPsm )
    private TsmIPort_ICtlrServer TsmPI__Port; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > Port )
    private TsmIPort_ICbCtlrServer Port; // ( Xmi > Data > Protocols > Ctlr > CtlrServer > Port )
    private TsmPSPort mPSMessager;

    public Cla_0061_0072( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0072_0074 = new Fsm_0072_0074( this );
      TsmPI__Port = new TsmIPort_ICtlrServer( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0072_0074;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Ctlr > CtlrServer )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICbCtlrServer) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Ctlr > CtlrServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0072_0074.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( CtlrServerPsm >> Starting ) => ( CtlrServerPsm >> Idle )
    public void Function_1004( TsmHandler oHandler )
    {
      Port.CbStarted((float)3.14);
    }

     // ( CtlrServerPsm >> Idle ) => ( CtlrServerPsm >> Starting )
    public int Function_1016( Boolean bStart )
    {
      return 83;
    }

     // ( CtlrServerPsm >> Idle ) => ( CtlrServerPsm >> Starting )
    public void Function_1017( TsmHandler oHandler )
    {
      TsmTrigger_ICtlrServer___Start lTrigger = (TsmTrigger_ICtlrServer___Start) oHandler.Trigger;
      Boolean bStart = lTrigger.bStart;

      lTrigger._RetVal = ((Cla_0061_0072)oHandler.Owner).Function_1016( bStart );
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 73;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0072_0074.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > Ctlr )
   ********************************************************************/

   // ( Xmi > Data > Protocols > Ctlr )
  public class Pac_0060_0061 : TsmPackage
  {
    public Pac_0060_0061( TsmBase oParent )
    {
      TsmName = "Ctlr";
      TsmParent = oParent;
    }
  }

  public interface IDriverServer
  {
    long Begin( int iPar );
  }

  public class TsmTrigger_IDriverServer___Begin : TsmTrigger
  {
    public long _RetVal;
    public int iPar;

    public TsmTrigger_IDriverServer___Begin( int iPar )
      : base( 3 )
    {
      this.iPar = iPar;
    }
  }

   // ( Xmi > Data > Protocols > Driver > IDriverServer )
  public class TsmIPort_IDriverServer : TsmInterfacePort, IDriverServer
  {
    public TsmIPort_IDriverServer( TsmBase oParent )
    {
      TsmName = "IDriverServer";
      TsmParent = oParent;
    }

    public virtual long Begin( int iPar )
    {
      TsmTrigger_IDriverServer___Begin tt = new TsmTrigger_IDriverServer___Begin( iPar );
      TsmRecorder.AddCall( "Begin", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
      return tt._RetVal;
    }
  }

  public interface ICbDriverServer
  {
    void CbBegin( double dPar );
  }

  public class TsmTrigger_ICbDriverServer___CbBegin : TsmTrigger
  {
    public double dPar;

    public TsmTrigger_ICbDriverServer___CbBegin( double dPar )
      : base( 2 )
    {
      this.dPar = dPar;
    }
  }

   // ( Xmi > Data > Protocols > Driver > ICbDriverServer )
  public class TsmIPort_ICbDriverServer : TsmInterfacePort, ICbDriverServer
  {
    public TsmIPort_ICbDriverServer( TsmBase oParent )
    {
      TsmName = "ICbDriverServer";
      TsmParent = oParent;
    }

    public virtual void CbBegin( double dPar )
    {
      TsmTrigger_ICbDriverServer___CbBegin tt = new TsmTrigger_ICbDriverServer___CbBegin( dPar );
      TsmRecorder.AddCall( "CbBegin", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> InitialState )
  public class Ini_0086_0087 : TsmPseudo
  {
    public Ini_0086_0087( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 90, "( DriverClientPsm >> InitialState ) => ( DriverClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 90; // TRLS ( DriverClientPsm >> InitialState ) => ( DriverClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90: // UP: ( DriverClientPsm >> InitialState ) => ( DriverClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> Idle )
  public class Lea_0086_0088 : TsmLeaf
  {
    int [] aNatives = { -91 };

    public Lea_0086_0088( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 91, "( DriverClientPsm >> Idle ) => ( DriverClientPsm >> Beginning )" );
    }

    public void Tra_0086_0090( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0086_0092( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 91:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 91: // Native: ( DriverClientPsm >> Idle ) => ( DriverClientPsm >> Beginning )
          TsmRecorder.AddNative( "( DriverClientPsm >> Idle ) => ( DriverClientPsm >> Beginning ) # lRv = Begin(iBeginPar);" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 91;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0086_0090( oHandler );
        break;
      case 91: // UP: ( DriverClientPsm >> Idle ) => ( DriverClientPsm >> Beginning )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 92:
        Tra_0086_0092( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> Beginning )
  public class Lea_0086_0089 : TsmLeaf
  {
    public Lea_0086_0089( TsmBase oParent )
    {
      TsmName = "Beginning";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 92, "( DriverClientPsm >> Beginning ) => ( DriverClientPsm >> Idle ) : CbBegin" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0086_0091( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbBegin( double dPar, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 92; // CbBegin
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 84:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 84: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 2: // Port___CbBegin
          {
            TsmTrigger_ICbDriverServer___CbBegin lTrigger = (TsmTrigger_ICbDriverServer___CbBegin) oHandler.Trigger;

            Port___CbBegin( lTrigger.dPar, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 91:
        Tra_0086_0091( oHandler );
        break;
      case 92: // UP: ( DriverClientPsm >> Beginning ) => ( DriverClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >)
  public class Reg_0085_0086 : TsmRegion
  {
    private Ini_0086_0087 oIni_0086_0087; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> InitialState )
    private Lea_0086_0088 oLea_0086_0088; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> Idle )
    private Lea_0086_0089 oLea_0086_0089; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >> Beginning )

    public Reg_0085_0086( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0086_0087 = new Ini_0086_0087( this );
      oLea_0086_0088 = new Lea_0086_0088( this );
      oLea_0086_0089 = new Lea_0086_0089( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0086_0087;
      mStates[ 1 ] = oLea_0086_0088;
      mStates[ 2 ] = oLea_0086_0089;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0086_0087.ExecuteHandler( oHandler );
    }

     // At: ( DriverClientPsm >> InitialState ) => ( DriverClientPsm >> Idle )
    public void Tra_0086_0090( TsmHandler oHandler )
    {
      mCurrentState = oLea_0086_0088; // At: ( DriverClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverClientPsm >> Idle ) => ( DriverClientPsm >> Beginning )
    public void Tra_0086_0091( TsmHandler oHandler )
    {
      ((Cla_0082_0083)oHandler.Owner).Function_1005( oHandler );
      mCurrentState = oLea_0086_0089; // At: ( DriverClientPsm >> Beginning )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverClientPsm >> Beginning ) => ( DriverClientPsm >> Idle )
    public void Tra_0086_0092( TsmHandler oHandler )
    {
      mCurrentState = oLea_0086_0088; // At: ( DriverClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 91:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 84:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0086_0090( oHandler );
        break;
      case 91:
        Tra_0086_0091( oHandler );
        break;
      case 92:
        Tra_0086_0092( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm )
  public class Fsm_0083_0085 : TsmFsm
  {
    private Reg_0085_0086 oReg_0085_0086; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm >)

    public Fsm_0083_0085( TsmBase oParent )
    {
      TsmName = "DriverClientPsm";
      TsmParent = oParent;
      oReg_0085_0086 = new Reg_0085_0086( this );
      mRegions.Add( oReg_0085_0086 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverClient )
  public class Cla_0082_0083 : TsmProtocolClass
  {
    private Fsm_0083_0085 oFsm_0083_0085; // ( Xmi > Data > Protocols > Driver > DriverClient > DriverClientPsm )
    private TsmIPort_IDriverServer Port; // ( Xmi > Data > Protocols > Driver > DriverClient > Port )
    private TsmIPort_ICbDriverServer TsmPI__Port; // ( Xmi > Data > Protocols > Driver > DriverClient > Port )
    private TsmPCPort mPCMessager;
    private long lRv = 0;
    private double dCbPar;
    private int iBeginPar = 101;

    public Cla_0082_0083( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0083_0085 = new Fsm_0083_0085( this );
      TsmPI__Port = new TsmIPort_ICbDriverServer( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0083_0085;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Driver > DriverClient )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_IDriverServer) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Driver > DriverClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0083_0085.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( DriverClientPsm >> Idle ) => ( DriverClientPsm >> Beginning )
    public void Function_1005( TsmHandler oHandler )
    {
      lRv = Port.Begin(iBeginPar);
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 84;
      TsmPI__Port.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0083_0085.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> InitialState )
  public class Ini_0096_0097 : TsmPseudo
  {
    public Ini_0096_0097( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 100, "( DriverServerPsm >> InitialState ) => ( DriverServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 100; // TRLS ( DriverServerPsm >> InitialState ) => ( DriverServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100: // UP: ( DriverServerPsm >> InitialState ) => ( DriverServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> Idle )
  public class Lea_0096_0098 : TsmLeaf
  {
    public Lea_0096_0098( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 101, "( DriverServerPsm >> Idle ) => ( DriverServerPsm >> Beginning ) : Begin" );
    }

    public void Tra_0096_0100( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0096_0102( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0096_0103( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Begin( int iPar, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 101; // Begin
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 94:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 94: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 3: // Port___Begin
          {
            TsmTrigger_IDriverServer___Begin lTrigger = (TsmTrigger_IDriverServer___Begin) oHandler.Trigger;

            Port___Begin( lTrigger.iPar, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100:
        Tra_0096_0100( oHandler );
        break;
      case 102:
        Tra_0096_0102( oHandler );
        break;
      case 103:
        Tra_0096_0103( oHandler );
        break;
      case 101: // UP: ( DriverServerPsm >> Idle ) => ( DriverServerPsm >> Beginning )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> Beginning )
  public class Lea_0096_0099 : TsmLeaf
  {
    int [] aNatives = { 102, 103 };

    public Lea_0096_0099( TsmBase oParent )
    {
      TsmName = "Beginning";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 102, "( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 103, "( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0096_0101( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 102:
          return TsmProspect.OK;
        case 103:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 102: // Native: ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
          TsmRecorder.AddNative( "( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle ) # CbBegin( dPar );" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 102;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        case 103: // Native: ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
          TsmRecorder.AddNative( "( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle ) # CbBegin( 3.14 );" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 103;
          oHandler.bTaken = true;
          mTransitions[ 1 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 102: // UP: ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 103: // UP: ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 101:
        Tra_0096_0101( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >)
  public class Reg_0095_0096 : TsmRegion
  {
    private Ini_0096_0097 oIni_0096_0097; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> InitialState )
    private Lea_0096_0098 oLea_0096_0098; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> Idle )
    private Lea_0096_0099 oLea_0096_0099; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >> Beginning )

    public Reg_0095_0096( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0096_0097 = new Ini_0096_0097( this );
      oLea_0096_0098 = new Lea_0096_0098( this );
      oLea_0096_0099 = new Lea_0096_0099( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0096_0097;
      mStates[ 1 ] = oLea_0096_0098;
      mStates[ 2 ] = oLea_0096_0099;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0096_0097.ExecuteHandler( oHandler );
    }

     // At: ( DriverServerPsm >> InitialState ) => ( DriverServerPsm >> Idle )
    public void Tra_0096_0100( TsmHandler oHandler )
    {
      mCurrentState = oLea_0096_0098; // At: ( DriverServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
    public void Tra_0096_0102( TsmHandler oHandler )
    {
      ((Cla_0082_0093)oHandler.Owner).Function_1006( oHandler );
      mCurrentState = oLea_0096_0098; // At: ( DriverServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
    public void Tra_0096_0103( TsmHandler oHandler )
    {
      ((Cla_0082_0093)oHandler.Owner).Function_1007( oHandler );
      mCurrentState = oLea_0096_0098; // At: ( DriverServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( DriverServerPsm >> Idle ) => ( DriverServerPsm >> Beginning )
    public void Tra_0096_0101( TsmHandler oHandler )
    {
      ((Cla_0082_0093)oHandler.Owner).Function_1019( oHandler );
      mCurrentState = oLea_0096_0099; // At: ( DriverServerPsm >> Beginning )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 102:
          return TsmProspect.OK;
        case 103:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 94:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 100:
        Tra_0096_0100( oHandler );
        break;
      case 102:
        Tra_0096_0102( oHandler );
        break;
      case 103:
        Tra_0096_0103( oHandler );
        break;
      case 101:
        Tra_0096_0101( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm )
  public class Fsm_0093_0095 : TsmFsm
  {
    private Reg_0095_0096 oReg_0095_0096; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm >)

    public Fsm_0093_0095( TsmBase oParent )
    {
      TsmName = "DriverServerPsm";
      TsmParent = oParent;
      oReg_0095_0096 = new Reg_0095_0096( this );
      mRegions.Add( oReg_0095_0096 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > Driver > DriverServer )
  public class Cla_0082_0093 : TsmProtocolClass
  {
    private Fsm_0093_0095 oFsm_0093_0095; // ( Xmi > Data > Protocols > Driver > DriverServer > DriverServerPsm )
    private TsmIPort_IDriverServer TsmPI__Port; // ( Xmi > Data > Protocols > Driver > DriverServer > Port )
    private TsmIPort_ICbDriverServer Port; // ( Xmi > Data > Protocols > Driver > DriverServer > Port )
    private TsmPSPort mPSMessager;
    private double dPar = 1.0;
    private long L10 = 55;

    public Cla_0082_0093( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0093_0095 = new Fsm_0093_0095( this );
      TsmPI__Port = new TsmIPort_IDriverServer( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0093_0095;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Driver > DriverServer )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICbDriverServer) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > Driver > DriverServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0093_0095.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
    public void Function_1006( TsmHandler oHandler )
    {
      Port.CbBegin( dPar );
    }

     // ( DriverServerPsm >> Beginning ) => ( DriverServerPsm >> Idle )
    public void Function_1007( TsmHandler oHandler )
    {
      Port.CbBegin( 3.14 );
    }

     // ( DriverServerPsm >> Idle ) => ( DriverServerPsm >> Beginning )
    public long Function_1018( int iPar )
    {
      return L10;
    }

     // ( DriverServerPsm >> Idle ) => ( DriverServerPsm >> Beginning )
    public void Function_1019( TsmHandler oHandler )
    {
      TsmTrigger_IDriverServer___Begin lTrigger = (TsmTrigger_IDriverServer___Begin) oHandler.Trigger;
      int iPar = lTrigger.iPar;

      lTrigger._RetVal = ((Cla_0082_0093)oHandler.Owner).Function_1018( iPar );
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 94;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0093_0095.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > Driver )
   ********************************************************************/

   // ( Xmi > Data > Protocols > Driver )
  public class Pac_0060_0082 : TsmPackage
  {
    public Pac_0060_0082( TsmBase oParent )
    {
      TsmName = "Driver";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols )
   ********************************************************************/

   // ( Xmi > Data > Protocols )
  public class Pac_0001_0060 : TsmPackage
  {
    public Pac_0001_0060( TsmBase oParent )
    {
      TsmName = "Protocols";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TismStereotypes )
   ********************************************************************/

   // ( Xmi > Data > TismStereotypes )
  public class Pac_0001_0104 : TsmPackage
  {
    public Pac_0001_0104( TsmBase oParent )
    {
      TsmName = "TismStereotypes";
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv2 > Driver2 )
  public class Com_0110_0001 : TsmPComponent
  {
    private Cla_0082_0093 InsDriverServer; // ( Xmi > Data > Protocols > Driver > DriverServer > InsDriverServer )

    public Com_0110_0001( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsDriverServer = new Cla_0082_0093( this, "InsDriverServer" );
      InsDriverServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsDriverServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        return InsDriverServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Driver2 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        InsDriverServer.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Driver2 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv2 > User2 )
  public class Com_0110_0003 : TsmPComponent
  {
    private Cla_0061_0062 InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

    public Com_0110_0003( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        return InsCtlrClient.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > User2 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        InsCtlrClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > User2 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv4 > User4 )
  public class Com_0114_0005 : TsmPComponent
  {
    private Cla_0061_0062 InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

    public Com_0114_0005( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        return InsCtlrClient.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv4 > User4 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        InsCtlrClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv4 > User4 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv3 > Driver3 )
  public class Com_0122_0007 : TsmPComponent
  {
    private Cla_0082_0093 InsDriverServer; // ( Xmi > Data > Protocols > Driver > DriverServer > InsDriverServer )

    public Com_0122_0007( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsDriverServer = new Cla_0082_0093( this, "InsDriverServer" );
      InsDriverServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsDriverServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        return InsDriverServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv3 > Driver3 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        InsDriverServer.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv3 > Driver3 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrDriver2 )
  public class Com_0126_0009 : TsmPComponent
  {
    private Cla_0082_0093 InsDriverServer; // ( Xmi > Data > Protocols > Driver > DriverServer > InsDriverServer )

    public Com_0126_0009( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsDriverServer = new Cla_0082_0093( this, "InsDriverServer" );
      InsDriverServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsDriverServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        return InsDriverServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrDriver2 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_Driver" :
        InsDriverServer.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrDriver2 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrUser2 )
  public class Com_0126_0011 : TsmPComponent
  {
    private Cla_0061_0062 InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

    public Com_0126_0011( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        return InsCtlrClient.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrUser2 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        InsCtlrClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv2 > ThrUser2 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv5 > User5 )
  public class Com_0130_0013 : TsmPComponent
  {
    private Cla_0061_0062 InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

    public Com_0130_0013( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        return InsCtlrClient.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv5 > User5 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        InsCtlrClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv5 > User5 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ThreadedExecEnv4 > ThrUser4 )
  public class Com_0134_0015 : TsmPComponent
  {
    private Cla_0061_0062 InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

    public Com_0134_0015( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        return InsCtlrClient.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv4 > ThrUser4 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        InsCtlrClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv4 > ThrUser4 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrUser5 )
  public class Com_0138_0017 : TsmPComponent
  {
    private Cla_0061_0062 InsCtlrClient; // ( Xmi > Data > Protocols > Ctlr > CtlrClient > InsCtlrClient )

    public Com_0138_0017( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCtlrClient = new Cla_0061_0062( this, "InsCtlrClient" );
      InsCtlrClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsCtlrClient;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        return InsCtlrClient.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrUser5 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_rp_User" :
        InsCtlrClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrUser5 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ThreadedExecEnv5 )
  public class Com_0105_0138 : TsmPComponent
  {
    private Com_0138_0017 ThrUser5; // ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrUser5 )
    private Com_0035_0048 ThrDriver5; // ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrDriver5 )
    private Com_0003_0017 ThrCtlr5; // ( Xmi > Data > Architecture > ThreadedExecEnv5 > ThrCtlr5 )

    public Com_0105_0138( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      ThrUser5 = new Com_0138_0017( this, "ThrUser5" );
      ThrDriver5 = new Com_0035_0048( this, "ThrDriver5" );
      ThrCtlr5 = new Com_0003_0017( this, "ThrCtlr5" );
      mNrComponents = 3;
      mComponents = new TsmComponent[ 3 ];
      mComponents[ 0 ] = ThrUser5;
      mComponents[ 1 ] = ThrDriver5;
      mComponents[ 2 ] = ThrCtlr5;
    }

    public override void TsmConnect( object oObject )
    {
      DoAssembly( ThrUser5, "d_rp_User", ThrCtlr5, "d_pp_User" );
      DoAssembly( ThrCtlr5, "d_pp_User", ThrUser5, "d_rp_User" );
      DoAssembly( ThrCtlr5, "d_rp_Driver", ThrDriver5, "d_pp_Driver" );
      DoAssembly( ThrDriver5, "d_pp_Driver", ThrCtlr5, "d_rp_Driver" );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
   ********************************************************************/

   // ( Xmi > Data > Architecture > Sequence Diagrams )
  public class Pac_0105_0142 : TsmPackage
  {
    public Pac_0105_0142( TsmBase oParent )
    {
      TsmName = "Sequence Diagrams";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture )
   ********************************************************************/

   // ( Xmi > Data > Architecture )
  public class Pac_0001_0105 : TsmPackage
  {
    public Pac_0001_0105( TsmBase oParent )
    {
      TsmName = "Architecture";
      TsmParent = oParent;
    }
  }

   // ( Xmi )
  public class TsmSystem : TsmExecComponent
  {
    private Com_0105_0138 ThreadedExecEnv5; // ( Xmi > Data > Architecture > ThreadedExecEnv5 )

    public TsmSystem( TsmBase oParent )
    {
      TsmName = "Xmi";
      TsmParent = oParent;
      mNrComponents = 1;
      mComponents = new TsmComponent[ 1 ];
      ThreadedExecEnv5 = new Com_0105_0138( null, "ThreadedExecEnv5" );
      mComponents[ 0 ] = ThreadedExecEnv5;
    }
  }
}
