﻿/*
 * TismTool © Tis Veugen, 2010-2012
 *
 * File: user.cs
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TsmRTE;
using System.Threading;

namespace Foreign
{
  public class UserClass : TsmClass, ICbCtlrServer
  {
    private MyTsmIPort_ICbCtlrServer TsmPI__Port;
    private TsmIPort_ICtlrServer Port;

    private int iRv;
    private bool bCallback = false;

    public UserClass( TsmBase oParent, string sInstanceName )
    {
      TsmPI__Port = new MyTsmIPort_ICbCtlrServer( this );
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "UserPort":
        return TsmPI__Port;
      default :
        break;
      }
      string s = "No port '" + sPortName + "' @ UserClass";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "UserPort":
        Port = (TsmIPort_ICtlrServer) oProvidedInterface;
        // Do NOT fill in Port.Source !!
        return;
      default :
        break;
      }
      string s = "No port '" + sPortName + "' @ UserClass";
      throw new TsmException( s );
    }

    public override void TsmRun( object oObject )
    {
      iRv = Port.Start(true);

      // Wait for response from callback function.
      // Use global variable and non-busy polling for synchronisation.
      while ( !bCallback )
      {
        Thread.Sleep( 100 );
      }

      // Grant time to CbThread to finish its callback activity.
      Thread.Sleep( 1000 );
    }

    // ( UserClientPsm >> Starting ) => ( UserClientPsm >> Idle )
    public void CbStarted( float fCbStart )
    {
      Tsm.Log( "CbStarted" );
      bCallback = true;
    }
  }


  public class UserForeign : TsmPComponent
  {
    private UserClass m_UserClass;

    public UserForeign( TsmBase oParent, string sInstanceName )
    {
      m_UserClass = new UserClass( this, "UserClass" );
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch ( sPortName )
      {
      case "d_rp_User":
        return m_UserClass.GetProvidedInterface( "UserPort" );
      default:
        break;
      }
      string s = "No port '" + sPortName + "' @ UserComponent";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch ( sPortName )
      {
      case "d_rp_User":
        m_UserClass.SetRequiredInterface( "UserPort", oProvidedInterface );
        return;
      default:
        break;
      }
      string s = "No port '" + sPortName + "' @ UserComponent";
      throw new TsmException( s );
    }

    public override void TsmRun( object oObject )
    {
      m_UserClass.TsmRun( oObject );
    }
  }


  public class MyTsmIPort_ICbCtlrServer : TsmIPort_ICbCtlrServer
  {
    private UserClass m_UserClass;

    public MyTsmIPort_ICbCtlrServer( UserClass oParent )
      : base( oParent )
    {
      m_UserClass = oParent;
    }

    public override void CbStarted( float fCbStart )
    {
      m_UserClass.CbStarted( fCbStart );
    }
  }
}
